/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package floyd.algorithm;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class App {

    public boolean doubleNaive(String word) {
        char[] letters = word.toCharArray();
        for(int i = 0; i < letters.length; i++) {
            for(int j = i +1; j < letters.length; j++) {
                if( letters[i] == letters[j]) {
                    return true;
                }
            }
        }
        return false;
    }

    public boolean doubleWithMap(String words) {
        Set<Character> letters = new HashSet<>();
        for (Character letter : words.toCharArray()) {
            if (letters.contains(letter)) {
                return true;
            }
            letters.add(letter);
        }

        return false;
    }

    public boolean doubleWithSort(String words) {
        char[] sortCharacters = words.toCharArray();
        Arrays.sort(sortCharacters);
        for(int i = 0; i < sortCharacters.length - 1; i++) {
            if(sortCharacters[i] == sortCharacters[i+1]) {
                return true;
            }
        }
        return false;
    }

    public boolean floyd(String word) {
        char[] letters = word.toCharArray();
        Map<Character, Integer> lettersIndex = new HashMap<>();
        if (letters.length <= 1) {
        return false;
        }

        lettersIndex.put(letters[0], 0);
        int fast = 2;
        int slow = 1;
        while(slow != letters.length) {
            if(!lettersIndex.containsKey(letters[slow])) {
                lettersIndex.put(letters[slow], slow);
                if (slow != lettersIndex.get(letters[slow])) {
                    return true;
                }
            } 
            if (!lettersIndex.containsKey(letters[fast])){
                lettersIndex.put(letters[fast], fast);
                fast = (fast + 2) % letters.length;
            } else {
                if (fast != lettersIndex.get(letters[fast])) {
                    return true;
                }
                fast = lettersIndex.get(letters[fast]);
            }
            slow++;
            if (fast == slow) {
                return true;
            }
        }
        
        return false;
    }

    public static void main(String[] args) {
        String toTest = "ambargo";
        App app = new App();
        long start = System.nanoTime();
        app.doubleWithSort(toTest);
        long end = System.nanoTime();
        long result = end - start;
        System.out.print("sort time execution: " + result + "\n");
    
        start = System.nanoTime();
        app.doubleWithMap(toTest);
        end = System.nanoTime();
        long resultMap = end - start;
        System.out.print("map time execution: " + resultMap + "\n");

        start = System.nanoTime();
        app.floyd(toTest);
        end = System.nanoTime();
        long resultFloyd = end - start;
        System.out.print("floyd time execution: " + resultFloyd + "\n");
    }
}
